﻿using System;
using Wisej.Web;

namespace Wisej.DGVCustomControlColumn
{
	public class DataGridViewProgressBarColumn : DataGridViewColumn
	{
		public DataGridViewProgressBarColumn()
			: base(new DatagridViewProgressBarCell())
		{
		}
	}

	public class DatagridViewProgressBarCell : DataGridViewCell
	{
		public DatagridViewProgressBarCell()
		{
		}

		public override DataGridViewCell Clone()
		{
			var cell = base.Clone();

			cell.Control = new ProgressBar()
			{
				Dock = DockStyle.Fill,
				Maximum = 100
			};

			return cell;
		}

		public override Type ValueType
		{
			get { return typeof(int); }
			set { }
		}

		public override Type FormattedValueType
		{
			get { return typeof(string); }
		}

		protected override bool SetValue(object value)
		{
			((ProgressBar)this.Control).Value = (int)value;

			return base.SetValue(value);
		}

		public override Type EditType
		{
			get
			{
				return typeof(DataGridViewTrackBarEditor);
			}
		}
	}

	public class DataGridViewTrackBarEditor : TrackBar, IDataGridViewEditingControl
	{
		public DataGridView DataGridView { get; set; }

		public bool Invalid
		{
			get { return false; }
		}

		public void ApplyCellStyleToEditingControl(DataGridViewCellStyle style)
		{
		}

		public string GetEditingControlFormattedValue()
		{
			return this.Value.ToString();
		}

		public void PrepareEditingControlForEdit(bool selectAll)
		{
			this.Value = Convert.ToInt32(this.DataGridView.CurrentCell.Value);
		}

		protected override void OnValueChanged(EventArgs e)
		{
			base.OnValueChanged(e);
			this.DataGridView?.NotifyCurrentCellDirty(true);
		}
	}
}